"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteMediaItem = exports.updateMediaItem = exports.getMediaItems = exports.uploadMediaItem = void 0;

var _services = require("../services");

const uploadMediaItem = async (_ref, dispatch, config) => {
  let {
    siteID,
    file
  } = _ref;
  const result = await _services.mediaServices.addMediaItem({
    siteID,
    file
  }, dispatch, config);
  return result;
};

exports.uploadMediaItem = uploadMediaItem;

const getMediaItems = async (_ref2, dispatch, config) => {
  let {
    siteID,
    page,
    limit
  } = _ref2;
  const result = await _services.mediaServices.getMediaItems({
    siteID,
    page,
    limit
  }, dispatch, config);
  return result;
};

exports.getMediaItems = getMediaItems;

const updateMediaItem = async (_ref3, dispatch, config) => {
  let {
    siteID,
    id,
    altText
  } = _ref3;
  const result = await _services.mediaServices.updateMediaItem({
    siteID,
    id,
    altText
  }, dispatch, config);
  return result;
};

exports.updateMediaItem = updateMediaItem;

const deleteMediaItem = async (_ref4, dispatch, config) => {
  let {
    siteID,
    id
  } = _ref4;
  const result = await _services.mediaServices.deleteMediaItem({
    siteID,
    id
  }, dispatch, config);
  return result;
};

exports.deleteMediaItem = deleteMediaItem;