"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.deleteTerm = exports.updateTerm = exports.addTerm = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _services = require("../services");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const addTerm = async (_ref, dispatch, config) => {
  let {
    siteID,
    taxonomyID,
    id,
    title,
    slug,
    parentID,
    description
  } = _ref;
  const result = await _services.termServices.addTerm({
    siteID,
    taxonomyID,
    id,
    title,
    slug,
    parentID,
    description
  }, dispatch, config);

  if (result) {
    dispatch({
      type: "ADD_TERM",
      payload: _objectSpread(_objectSpread({}, result), {}, {
        taxonomyID,
        siteID
      })
    });
  }

  return result;
};

exports.addTerm = addTerm;

const updateTerm = async (_ref2, dispatch, config) => {
  let {
    siteID,
    taxonomyID,
    id,
    title,
    slug,
    parentID,
    description
  } = _ref2;
  const result = await _services.termServices.updateTerm({
    siteID,
    taxonomyID,
    id,
    title,
    slug,
    parentID,
    description
  }, dispatch, config);

  if (result) {
    dispatch({
      type: "UPDATE_TERM",
      payload: _objectSpread(_objectSpread({}, result), {}, {
        taxonomyID,
        siteID
      })
    });
  }

  return result;
};

exports.updateTerm = updateTerm;

const deleteTerm = async (_ref3, dispatch, config) => {
  let {
    siteID,
    taxonomyID,
    id
  } = _ref3;
  const result = await _services.termServices.deleteTerm({
    siteID,
    taxonomyID,
    id
  }, dispatch, config);

  if (result) {
    dispatch({
      type: "DELETE_TERM",
      payload: _objectSpread(_objectSpread({}, result), {}, {
        taxonomyID,
        siteID
      })
    });
  }

  return result;
};

exports.deleteTerm = deleteTerm;