"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _icons = require("@ant-design/icons");

var _store = require("../store");

var _actions = require("../actions");

var _templateObject, _templateObject2;

const DeploymentBadge = props => {
  var _authUser$capabilitie;

  const {
    deployment: {
      badgeImage,
      badgeLink,
      buildHook,
      lastBuild
    }
  } = props;
  const [{
    config,
    authState: {
      authUser
    },
    cmsState: {
      siteID,
      sites,
      deploymentImage
    }
  }, dispatch] = (0, _store.useStore)();
  (0, _react.useEffect)(() => {
    let interval = null;

    if (badgeImage) {
      interval = setInterval(() => {
        // We use a central deployment badge image instead of the one in the site object to avoid a flickering
        // when deploy is triggered and user navigates between pages
        dispatch({
          type: 'SET_DEPLOYMENT_IMAGE',
          payload: "".concat(badgeImage, "?v=").concat(Math.floor(Math.random() * Math.floor(100)))
        });
      }, 10000);
    }

    return () => clearInterval(interval);
  }, []);

  const handleDeploy = async () => {
    await _actions.siteActions.deploySite({
      id: siteID
    }, dispatch, config);

    if (badgeImage) {
      dispatch({
        type: 'SET_DEPLOYMENT_IMAGE',
        payload: "".concat(badgeImage, "?v=").concat(Math.floor(Math.random() * Math.floor(100)))
      });
    }
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    size: 20
  }, (deploymentImage || badgeImage) && lastBuild && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, badgeLink && authUser !== null && authUser !== void 0 && (_authUser$capabilitie = authUser.capabilities) !== null && _authUser$capabilitie !== void 0 && _authUser$capabilitie.manage_options ? /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: "Open Deploy",
    placement: "bottom"
  }, /*#__PURE__*/_react.default.createElement(DeploymentLink, {
    href: badgeLink,
    target: "_blank",
    rel: "noopener noreferrer"
  }, /*#__PURE__*/_react.default.createElement(DeploymentStatus, {
    src: deploymentImage || badgeImage
  }))) : /*#__PURE__*/_react.default.createElement(DeploymentStatus, {
    src: deploymentImage || badgeImage
  })), buildHook && /*#__PURE__*/_react.default.createElement(_antd.Tooltip, {
    title: "Deploy Website",
    placement: "bottom"
  }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    icon: /*#__PURE__*/_react.default.createElement(_icons.DeploymentUnitOutlined, null),
    onClick: handleDeploy
  })));
};

const DeploymentLink = _styledComponents.default.a(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  height: 32px;\n  display: flex;\n  align-items: center;\n"])));

const DeploymentStatus = _styledComponents.default.img(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  height: 16px;\n  margin: 0 10px;\n"])));

var _default = DeploymentBadge;
exports.default = _default;