"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _antd = require("antd");

var _router = require("@reach/router");

var _htmlReactParser = _interopRequireDefault(require("html-react-parser"));

var _GatsbyImage = _interopRequireDefault(require("./GatsbyImage"));

var _theme = require("../theme");

var _templateObject, _templateObject2, _templateObject3;

const ListItem = props => {
  const {
    level = 0,
    link,
    actions,
    title,
    subtitle,
    status,
    image,
    showImage = false,
    info = ''
  } = props,
        rest = (0, _objectWithoutProperties2.default)(props, ["level", "link", "actions", "title", "subtitle", "status", "image", "showImage", "info"]);

  const listItemTitle = /*#__PURE__*/_react.default.createElement(_antd.Typography.Text, {
    strong: true
  }, (0, _htmlReactParser.default)(title || ''), status);

  let metaTitle = link ? /*#__PURE__*/_react.default.createElement(StyledLink, {
    to: link
  }, listItemTitle) : listItemTitle;

  if (info) {
    metaTitle = /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, metaTitle, " - ", info);
  }

  return /*#__PURE__*/_react.default.createElement(Container, (0, _extends2.default)({
    level: level
  }, rest), /*#__PURE__*/_react.default.createElement(_antd.Card, null, /*#__PURE__*/_react.default.createElement(_antd.List.Item, {
    actions: actions
  }, /*#__PURE__*/_react.default.createElement(_antd.List.Item.Meta, {
    avatar: showImage && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, image ? /*#__PURE__*/_react.default.createElement(_GatsbyImage.default, {
      image: image,
      objectFit: "cover",
      objectPosition: "50% 50%",
      alt: image.alt,
      style: {
        width: '50px',
        height: '50px'
      }
    }) : /*#__PURE__*/_react.default.createElement(ImagePlaceholder, null)),
    title: metaTitle,
    description: subtitle
  }))));
};

const Container = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  margin-left: ", ";\n\n  .ant-card-body {\n    padding: 0 20px;\n  }\n"])), (_ref) => {
  let {
    level
  } = _ref;
  return "".concat(level * 30, "px");
});

const ImagePlaceholder = _styledComponents.default.div(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  width: 50px;\n  height: 50px;\n  background: ", ";\n"])), _theme.colors.tertiary);

const StyledLink = (0, _styledComponents.default)(_router.Link)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  && {\n    flex: 1;\n\n    &:hover {\n      .ant-typography {\n        color: ", ";\n      }\n    }\n  }\n"])), _theme.colors.primary);
var _default = ListItem;
exports.default = _default;