"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _auth = require("../utils/auth");

var _store = require("../store");

var _actions = require("../actions");

// import app components
const PrivateRoute = props => {
  const {
    component: Component,
    location
  } = props,
        rest = (0, _objectWithoutProperties2.default)(props, ["component", "location"]);
  const [{
    config
  }, dispatch] = (0, _store.useStore)();
  const loggedIn = (0, _auth.isLoggedIn)(config);
  const previewID = (0, _auth.isPreview)();
  (0, _react.useEffect)(() => {
    const {
      location
    } = props;

    if (!loggedIn && !previewID && location.pathname !== "/") {
      _actions.authActions.signOut({}, dispatch, config);
    }
  }, [loggedIn, previewID]);
  return loggedIn || previewID ? /*#__PURE__*/_react.default.createElement(Component, rest) : null;
};

var _default = PrivateRoute;
exports.default = _default;