"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Select = _interopRequireDefault(require("./Select"));

var _Input = _interopRequireDefault(require("./Input"));

var _store = require("../store");

// import app components
const TermForm = props => {
  const {
    id,
    title: defaultTitle = '',
    slug: defaultSlug = '',
    parentID: defaultParentID = 0,
    description: defaultDescription = '',
    terms,
    onSubmit
  } = props;
  const termExists = !!id;
  const [, dispatch] = (0, _store.useStore)();
  const [title, setTitle] = (0, _react.useState)(defaultTitle);
  const [slug, setSlug] = (0, _react.useState)(defaultSlug);
  const [parentID, setParentID] = (0, _react.useState)(defaultParentID);
  const [description, setDescription] = (0, _react.useState)(defaultDescription);

  const handleSubmit = async () => {
    if (!title) {
      return;
    }

    await onSubmit({
      id,
      title,
      slug,
      parentID,
      description
    });
    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Title",
    value: title,
    onChange: e => setTitle(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "slug",
    value: slug,
    onChange: e => setSlug(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Input.default, {
    rows: 4,
    label: "Description",
    value: description,
    allowClear: true,
    onChange: e => setDescription(e.target.value),
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_Select.default, {
    value: parentID,
    onChange: value => setParentID(value),
    label: 'Parent'
  }, /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    value: 0,
    children: "None"
  }), terms && terms.filter(o => o.id !== id).map(o => /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    key: o.id,
    value: o.id,
    children: o.title
  })))), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: termExists ? 'Update' : 'Add',
    onClick: handleSubmit,
    type: "primary",
    block: true
  }));
};

var _default = TermForm;
exports.default = _default;