"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _Input = _interopRequireDefault(require("./Input"));

var _Caption = _interopRequireDefault(require("./Caption"));

var _store = require("../store");

// import app components
const UserForm = props => {
  const {
    id,
    email: defaultEmail = '',
    role: defaultRole = 'editor',
    onAdd,
    onUpdate
  } = props;
  const [, dispatch] = (0, _store.useStore)();
  const [email, setEmail] = (0, _react.useState)(defaultEmail);
  const [role, setRole] = (0, _react.useState)(defaultRole);
  const userExists = !!id;

  const handleSubmit = async () => {
    if (!email || !role) {
      return;
    }

    if (id) {
      onUpdate({
        id,
        role
      });
    } else {
      onAdd({
        email,
        role
      });
    }

    dispatch({
      type: 'CLOSE_DIALOG'
    });
  };

  return /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 20
  }, /*#__PURE__*/_react.default.createElement(_Input.default, {
    label: "Email",
    value: email,
    onChange: e => setEmail(e.target.value),
    placeholder: "",
    disabled: !!defaultEmail,
    onKeyDown: e => e.key === 'Enter' && handleSubmit()
  }), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 2
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: "Role"
  }), /*#__PURE__*/_react.default.createElement(_antd.Select, {
    defaultValue: role || defaultRole,
    onChange: v => setRole(v)
  }, /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    value: 'subscriber',
    children: 'Subscriber'
  }), /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    value: 'editor',
    children: 'Editor'
  }), /*#__PURE__*/_react.default.createElement(_antd.Select.Option, {
    value: 'administrator',
    children: 'Admin'
  }))), /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: userExists ? 'Update' : 'Add',
    onClick: handleSubmit,
    type: "primary"
  }));
};

var _default = UserForm;
exports.default = _default;