"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _googleMapReact = _interopRequireDefault(require("google-map-react"));

var _reactGeocode = _interopRequireDefault(require("react-geocode"));

var _antd = require("antd");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _icons = require("@ant-design/icons");

var _theme = require("../../theme");

var _templateObject, _templateObject2;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const Marker = () => /*#__PURE__*/_react.default.createElement(Icon, null, /*#__PURE__*/_react.default.createElement(_icons.EnvironmentTwoTone, null));

const Map = props => {
  const {
    site,
    value,
    onChange
  } = props;
  let defaultValue = value || {
    lat: 59.95,
    lng: 30.33,
    address: ''
  };
  (0, _react.useEffect)(() => {
    (site === null || site === void 0 ? void 0 : site.googleMapsApi) && _reactGeocode.default.setApiKey(site.googleMapsApi);
  }, []);

  const handleSearch = async address => {
    try {
      var _result$results;

      const result = await _reactGeocode.default.fromAddress(address);
      const {
        geometry: {
          location: {
            lat,
            lng
          }
        },
        formatted_address
      } = result === null || result === void 0 ? void 0 : (_result$results = result.results) === null || _result$results === void 0 ? void 0 : _result$results[0];

      if (lat, lng) {
        onChange({
          address: formatted_address || '',
          lat,
          lng
        });
      }
    } catch (err) {
      console.log(err);
    }
  };

  const handleGeocode = async (lat, lng) => {
    var _result$results2;

    const result = await _reactGeocode.default.fromLatLng(lat, lng);
    const {
      formatted_address
    } = result === null || result === void 0 ? void 0 : (_result$results2 = result.results) === null || _result$results2 === void 0 ? void 0 : _result$results2[0];

    if (formatted_address) {
      onChange({
        address: formatted_address,
        lat,
        lng
      });
    }
  };

  const handleChange = e => {
    onChange(_objectSpread(_objectSpread({}, defaultValue), {}, {
      address: e.target.value
    }));
  };

  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, site !== null && site !== void 0 && site.googleMapsApi ? /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical"
  }, /*#__PURE__*/_react.default.createElement(_antd.Input.Search, {
    value: defaultValue.address,
    onChange: handleChange,
    onSearch: () => handleSearch(defaultValue.address),
    placeholder: (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.address) || 'Enter an address'
  }), /*#__PURE__*/_react.default.createElement(MapContainer, null, /*#__PURE__*/_react.default.createElement(_googleMapReact.default, {
    height: true,
    bootstrapURLKeys: {
      key: site.googleMapsApi
    },
    defaultCenter: {
      lat: 59.95,
      ln: 30.33
    },
    defaultZoom: 11,
    center: [defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.lat, defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.lng],
    onClick: (_ref) => {
      let {
        lat,
        lng
      } = _ref;
      return handleGeocode(lat, lng);
    }
  }, (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.lat) && (defaultValue === null || defaultValue === void 0 ? void 0 : defaultValue.lng) && /*#__PURE__*/_react.default.createElement(Marker, {
    lat: defaultValue.lat,
    lng: defaultValue.lng
  })))) : /*#__PURE__*/_react.default.createElement(_antd.Typography, null, "Please add GoogleMaps API key in settings."));
};

const MapContainer = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  height: 220px;\n  width: 100%;\n  background: ", ";\n"])), _theme.colors.tertiary);

const Icon = _styledComponents.default.div(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  svg {\n    height: 26px;\n    width: 20px;\n  }\n"])));

var _default = Map;
exports.default = _default;