"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _antd = require("antd");

var _immer = _interopRequireDefault(require("immer"));

var _icons = require("@ant-design/icons");

var _reactBeautifulDnd = require("react-beautiful-dnd");

var _Caption = _interopRequireDefault(require("../Caption"));

var _EditorFields = require("../EditorFields");

var _theme = require("../../theme");

var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

const Repeater = props => {
  const {
    id,
    label,
    instructions,
    site,
    items,
    value,
    onChange,
    dispatch
  } = props;
  const values = value || [];
  const [childActive, setChildActive] = (0, _react.useState)([]);

  const handleAdd = () => {
    const newValues = (0, _immer.default)(values, draft => {
      if (items) {
        draft.push(items.reduce((ac, a) => _objectSpread(_objectSpread({}, ac), {}, {
          [a.id]: a.defaultValue || ''
        }), {}));
      }

      return draft;
    });
    onChange(newValues);
    handleToggleChild(values.length);
  };

  const handleRemove = index => {
    const newValues = (0, _immer.default)(values, draft => {
      draft.splice(index, 1);
      return draft;
    });
    onChange(newValues);
  };

  const handleChange = (item, index) => {
    const newValues = (0, _immer.default)(values, draft => {
      draft[index][item.id] = item.value;
      return draft;
    });
    onChange(newValues);
  };

  const getListStyle = isDraggingOver => ({
    background: isDraggingOver ? _theme.colors.tertiary : '#fff',
    padding: 2
  });

  const getItemStyle = (isDragging, draggableStyle) => _objectSpread({
    userSelect: 'none',
    padding: 2
  }, draggableStyle);

  const handleDragEnd = result => {
    // dropped outside the list
    if (!result.destination) {
      return;
    }

    const index = result.source.index;
    const newIndex = result.destination.index;
    const newValues = (0, _immer.default)(values, draft => {
      if (newIndex > -1 && newIndex < draft.length) {
        const temp = draft[index];
        draft[index] = draft[newIndex];
        draft[newIndex] = temp;
      }

      return draft;
    });
    onChange(newValues);
  };

  const handleToggleChild = key => {
    const newKeys = (0, _immer.default)(childActive, draft => {
      if (childActive.includes(key)) {
        draft = draft.filter(k => k !== key);
      } else {
        draft.push(key);
      }

      return draft;
    });
    setChildActive(newKeys);
  };

  return /*#__PURE__*/_react.default.createElement(Container, null, /*#__PURE__*/_react.default.createElement(LabelContainer, null, /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 6
  }, /*#__PURE__*/_react.default.createElement(_Caption.default, {
    children: label || id
  }), instructions && /*#__PURE__*/_react.default.createElement(_antd.Typography.Text, {
    type: "secondary",
    children: instructions
  }))), values && /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.DragDropContext, {
    onDragEnd: handleDragEnd
  }, /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.Droppable, {
    droppableId: "droppable"
  }, (provided, snapshot) => /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, provided.droppableProps, {
    ref: provided.innerRef,
    style: getListStyle(snapshot.isDraggingOver)
  }), values.map((value, index) => {
    return /*#__PURE__*/_react.default.createElement(_reactBeautifulDnd.Draggable, {
      key: index,
      draggableId: "item-".concat(index),
      index: index,
      isDragDisabled: childActive.includes(index)
    }, (provided, snapshot) => /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({
      ref: provided.innerRef
    }, provided.draggableProps, provided.dragHandleProps, {
      style: getItemStyle(snapshot.isDragging, provided.draggableProps.style)
    }), /*#__PURE__*/_react.default.createElement(_antd.Collapse, {
      activeKey: childActive,
      onChange: () => handleToggleChild(index),
      expandIconPosition: "right"
    }, /*#__PURE__*/_react.default.createElement(_antd.Collapse.Panel, {
      key: index,
      header: "Item ".concat(index + 1),
      extra: /*#__PURE__*/_react.default.createElement(DeleteIcon, {
        className: "icon",
        onClick: e => e.stopPropagation()
      }, /*#__PURE__*/_react.default.createElement(DeleteIconContainer, null, /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
        title: "Are you sure\uFF1F",
        onConfirm: () => handleRemove(index),
        icon: /*#__PURE__*/_react.default.createElement(_icons.QuestionCircleOutlined, {
          style: {
            color: _theme.colors.warning
          }
        }),
        placement: "left"
      }, /*#__PURE__*/_react.default.createElement(_icons.DeleteTwoTone, {
        twoToneColor: _theme.colors.warning
      }))))
    }, items && items.map((field, subIndex) => {
      return /*#__PURE__*/_react.default.createElement("div", {
        key: subIndex
      }, (0, _EditorFields.getField)({
        field: _objectSpread(_objectSpread({}, field), {}, {
          value: value[field.id]
        }),
        index,
        site,
        onChangeElement: value => handleChange(value, index),
        dispatch
      }));
    })))));
  }), provided.placeholder))), /*#__PURE__*/_react.default.createElement(AddContainer, null, /*#__PURE__*/_react.default.createElement(AddButton, {
    siblings: values && values.length > 0,
    onClick: handleAdd
  }, /*#__PURE__*/_react.default.createElement(_icons.PlusOutlined, null))));
};

const Container = _styledComponents.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  background: #fff;\n\n  .ant-collapse-item {\n    position: relative;\n  }\n\n  .ant-collapse > .ant-collapse-item > .ant-collapse-header {\n    cursor: grab;\n  }\n"])));

const LabelContainer = _styledComponents.default.div(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  padding: 12px 4px 0;\n"])));

const DeleteIconContainer = _styledComponents.default.div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  width: 20px;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  padding: 10px;\n  opacity: ", ";\n"])), props => props.disabled ? 0.4 : 1);

const DeleteIcon = _styledComponents.default.div(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["\n  position: absolute;\n  z-index: 2;\n  right: 50px;\n  top: 0;\n  height: 100%;\n  display: flex;\n"])));

const AddContainer = _styledComponents.default.div(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2.default)(["\n  padding: 4px;\n"])));

const AddButton = _styledComponents.default.div(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  height: 46px;\n  width: 100%;\n  border: 1px solid transparent;\n  cursor: pointer;\n  transition: ease-in all 0.2s;\n\n  &:hover {\n    border-color: ", ";\n  }\n\n  ", "\n"])), _theme.colors.tertiary, (_ref) => {
  let {
    siblings
  } = _ref;
  return !siblings && (0, _styledComponents.css)(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2.default)(["\n      border-color: ", ";\n\n      &:hover {\n        border-color: #c9cfdb;\n      }\n    "])), _theme.colors.tertiary);
});

var _default = Repeater;
exports.default = _default;