"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _antd = require("antd");

var _CmsLayout = _interopRequireDefault(require("../components/CmsLayout"));

var _TermForm = _interopRequireDefault(require("../components/TermForm"));

var _ListItem = _interopRequireDefault(require("../components/ListItem"));

var _utils = require("../utils");

var _actions = require("../actions");

var _store = require("../store");

// import app components
const Taxonomy = props => {
  var _sites$siteID, _sites$siteID$taxonom, _config$fields, _config$fields$taxono, _config$fields$taxono2;

  const {
    taxonomyID
  } = props;
  const [{
    config,
    cmsState: {
      siteID,
      sites
    }
  }, dispatch] = (0, _store.useStore)();
  const [isSyncing, setIsSyncing] = (0, _react.useState)(false);
  const taxonomy = (_sites$siteID = sites[siteID]) === null || _sites$siteID === void 0 ? void 0 : (_sites$siteID$taxonom = _sites$siteID.taxonomies) === null || _sites$siteID$taxonom === void 0 ? void 0 : _sites$siteID$taxonom[taxonomyID];
  const terms = taxonomy !== null && taxonomy !== void 0 && taxonomy.terms ? (0, _utils.createDataTree)(taxonomy.terms) : [];

  const handleSync = async () => {
    var _sites$siteID2;

    setIsSyncing(true);
    await _actions.siteActions.syncFields({
      fields: config.fields,
      apiKey: (_sites$siteID2 = sites[siteID]) === null || _sites$siteID2 === void 0 ? void 0 : _sites$siteID2.apiKey
    }, dispatch, config);
    setIsSyncing(false);
  };

  const handleUpsert = async (_ref) => {
    let {
      id,
      title,
      slug,
      parentID,
      description
    } = _ref;

    if (id) {
      await _actions.termActions.updateTerm({
        siteID,
        taxonomyID,
        id,
        title,
        slug,
        parentID,
        description
      }, dispatch, config);
    } else {
      await _actions.termActions.addTerm({
        siteID,
        taxonomyID,
        id,
        title,
        slug,
        parentID,
        description
      }, dispatch, config);
    }
  };

  const handleDelete = async (_ref2) => {
    let {
      termID
    } = _ref2;
    await _actions.termActions.deleteTerm({
      siteID,
      taxonomyID,
      id: termID
    }, dispatch, config);
  };

  const handleOpenDialog = term => {
    dispatch({
      type: 'SET_DIALOG',
      payload: {
        open: true,
        title: "Term",
        component: /*#__PURE__*/_react.default.createElement(_TermForm.default, (0, _extends2.default)({}, term, {
          terms: taxonomy === null || taxonomy === void 0 ? void 0 : taxonomy.terms,
          onSubmit: handleUpsert
        }))
      }
    });
  };

  const renderTerm = (o, level) => {
    const actions = [];
    actions.push( /*#__PURE__*/_react.default.createElement(_antd.Popconfirm, {
      title: "Are you sure?",
      onConfirm: () => handleDelete({
        termID: o.id
      }),
      okText: "Yes",
      cancelText: "No"
    }, /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      children: "Delete",
      danger: true
    })));
    actions.push( /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      children: "Edit",
      onClick: () => handleOpenDialog(o)
    }));
    return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
      key: o.id
    }, /*#__PURE__*/_react.default.createElement(_ListItem.default, {
      level: level,
      actions: actions,
      title: o.title,
      subtitle: o.slug
    }), o.childNodes.map(p => renderTerm(p, level + 1)));
  };

  return /*#__PURE__*/_react.default.createElement(_CmsLayout.default, {
    pageTitle: (config === null || config === void 0 ? void 0 : (_config$fields = config.fields) === null || _config$fields === void 0 ? void 0 : (_config$fields$taxono = _config$fields.taxonomies) === null || _config$fields$taxono === void 0 ? void 0 : (_config$fields$taxono2 = _config$fields$taxono.find(o => o.id === taxonomyID)) === null || _config$fields$taxono2 === void 0 ? void 0 : _config$fields$taxono2.title) || (taxonomy === null || taxonomy === void 0 ? void 0 : taxonomy.title)
  }, /*#__PURE__*/_react.default.createElement(_antd.PageHeader, null, /*#__PURE__*/_react.default.createElement(_antd.Button, {
    children: "Add",
    onClick: () => handleOpenDialog(),
    type: "primary",
    disabled: !taxonomy
  })), !taxonomy && /*#__PURE__*/_react.default.createElement(_antd.Alert, {
    message: "Unknown taxonomy",
    description: "Restart the development process or sync new data now",
    type: "info",
    showIcon: true,
    action: /*#__PURE__*/_react.default.createElement(_antd.Button, {
      size: "small",
      type: "ghost",
      onClick: handleSync,
      loading: isSyncing
    }, "Sync to WordPress")
  }), /*#__PURE__*/_react.default.createElement(_antd.Space, {
    direction: "vertical",
    size: 8
  }, terms && terms.map(item => renderTerm(item, 0))));
};

var _default = Taxonomy;
exports.default = _default;