"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.refreshToken = exports.resetPassword = exports.forgetPassword = exports.signIn = void 0;

var _axios = _interopRequireDefault(require("axios"));

var _actions = require("../actions");

// import app components
// TODO: add trailing slash function to utils and pass in endpoint via settings (doesn't need to be /graphql)
const getEndpoint = url => "".concat(url.replace(/\/+$/, ''), "/graphql");

const signIn = async (_ref, url) => {
  let {
    email,
    password
  } = _ref;

  try {
    const endpoint = getEndpoint(url);
    const result = await _axios.default.post(endpoint, {
      query: "\n        mutation  {\n          login(\n            input: {\n              username: \"".concat(email, "\"\n              password: \"").concat(password, "\"\n              clientMutationId: \"login\"\n            }\n          ) {\n            authToken\n            refreshToken\n            user{\n              capabilities\n            }\n          }\n        }\n      ")
    });
    return result === null || result === void 0 ? void 0 : result.data;
  } catch (err) {
    console.log(err);
  }
};

exports.signIn = signIn;

const forgetPassword = async (_ref2, url) => {
  let {
    email
  } = _ref2;
  const endpoint = getEndpoint(url);
  const result = await _axios.default.post(endpoint, {
    query: "\n      mutation {\n        sendPasswordResetEmail(\n          input: {\n            username: \"".concat(email, "\"\n            clientMutationId: \"forgotPassword\"\n          }\n        ) {\n          user {\n            email\n          }\n        }\n      }\n    ")
  });
  return result === null || result === void 0 ? void 0 : result.data;
};

exports.forgetPassword = forgetPassword;

const resetPassword = async (_ref3, url) => {
  let {
    key,
    login,
    password
  } = _ref3;
  const endpoint = getEndpoint(url);
  const result = await _axios.default.post(endpoint, {
    query: "\n      mutation {\n        resetUserPassword(\n          input: {\n            key: \"".concat(key, "\"\n            login: \"").concat(login, "\"\n            password: \"").concat(password, "\"\n            clientMutationId: \"changePassword\"\n          }\n        ) {\n          user {\n            email\n          }\n        }\n      }\n    ")
  });
  return result === null || result === void 0 ? void 0 : result.data;
};

exports.resetPassword = resetPassword;

const refreshToken = async (_ref4, dispatch, config) => {
  var _result$errors;

  let {
    refreshToken
  } = _ref4;
  const endpoint = getEndpoint(config.source);
  const result = await _axios.default.post(endpoint, {
    query: "\n      mutation {\n        refreshJwtAuthToken(\n          input: {\n            jwtRefreshToken: \"".concat(refreshToken, "\"\n            clientMutationId: \"refreshToken\"\n          }\n        ) {\n          authToken\n        }\n      }\n    ")
  });

  if ((result === null || result === void 0 ? void 0 : (_result$errors = result.errors) === null || _result$errors === void 0 ? void 0 : _result$errors.length) > 0) {
    _actions.authActions.signOut({}, dispatch, config);
  }

  return result === null || result === void 0 ? void 0 : result.data;
};

exports.refreshToken = refreshToken;