"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addPost;

var _router = require("@reach/router");

var _lodash = require("lodash");

var _immer = _interopRequireDefault(require("immer"));

var _actions = require("../actions");

var _generateSlug = _interopRequireDefault(require("./generateSlug"));

// import app components
async function addPost(_ref, dispatch, config) {
  let {
    site,
    postTypeID,
    title,
    parentID
  } = _ref;
  const result = await _actions.postActions.addPost({
    siteID: site.id,
    postTypeID,
    status: 'draft',
    title,
    parentID
  }, dispatch, config);

  if (result !== null && result !== void 0 && result.id) {
    var _site$postTypes;

    const postType = site === null || site === void 0 ? void 0 : (_site$postTypes = site.postTypes) === null || _site$postTypes === void 0 ? void 0 : _site$postTypes[postTypeID]; // Add post to post type so we can then generate the slug and the route the newly created post

    const nextPostType = (0, _immer.default)(postType, draft => {
      return (0, _lodash.set)(draft, "posts.".concat(result.id), result);
    });
    const slug = (0, _generateSlug.default)(nextPostType, result.id, site === null || site === void 0 ? void 0 : site.frontPage);
    (0, _router.navigate)("/".concat(slug));
  }
}