"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = generateSlug;

var _formatSlug = _interopRequireDefault(require("./formatSlug"));

var _getParentSlug = _interopRequireDefault(require("./getParentSlug"));

function generateSlug(postType, postID, frontPage) {
  var _postType$posts;

  let trailingSlash = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  if (postID === frontPage) {
    return trailingSlash ? '/' : '';
  }

  if (!(postType !== null && postType !== void 0 && (_postType$posts = postType.posts) !== null && _postType$posts !== void 0 && _postType$posts[postID])) {
    return '';
  }

  const {
    slug: postTypeSlug,
    posts,
    posts: {
      [postID]: {
        slug: postSlug,
        parentID
      }
    }
  } = postType;
  const parentSlug = (0, _getParentSlug.default)(posts, parentID);
  const slug = (0, _formatSlug.default)("".concat(postTypeSlug, "/").concat(parentSlug, "/").concat(postSlug), trailingSlash);
  return slug;
}